﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Windows.Forms;


namespace CAN_2026C_demo
{
    public partial class Form1 : Form
    {
    	//Global Variable for time value, last voltage value and timer
        Byte VxCAN_port;
		int count;
		float VoltLast;
		System.Windows.Forms.Timer Timer1 = new System.Windows.Forms.Timer();

		
		public Form1()
        {
            InitializeComponent();
        }

        private void Btn_GetDLLVersion_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            Char[] ch = new Char[600];
                        
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_DLL_Ver(ch);
            if (ret == 0)
            {
                String _str = new String(ch);
                MessageBox.Show(_str);
            } 
        }

        private void Btn_SearchModule_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            byte Percentage = 0;
            pBar_SearchModule.Value = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_SearchCANModule();
            if (ret == 0)
            {
                while (pBar_SearchModule.Value < pBar_SearchModule.Maximum)
                {

                    ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_IsSearchCANModuleOK(ref Percentage);
                    pBar_SearchModule.Value = Convert.ToInt32(Percentage);                  
                }

                MessageBox.Show("Search Done!");
            }
        }

        private void Btn_GetModuleList_Click(object sender, EventArgs e)
        {
            Byte _TotalVxCANPort=0;
            Byte[] _VxCAN_LocalPortIDList = new Byte[50];
            UInt32 ret = 0;
            UInt32[] _VxCAN_NameIDList = new UInt32[50];
            UInt32[] _VxCAN_IDList = new UInt32[50];
            UInt32[] _VxCAN_COMPortBaudRate = new UInt32[50];
            String[] _VxCAN_NameStr = new String[50];
            String[] _VxCAN_VerStr = new String[50];

            dataGridView1.Columns.Clear();
            dataGridView1.Rows.Clear();
            dataGridView1.Columns.Add("VxCANPort", "VxCANPort");
            dataGridView1.Columns.Add("VxCAN_NameIDList", "VxCAN_NameIDList");
            dataGridView1.Columns.Add("VxCAN_IDList", "VxCAN_IDList");
            dataGridView1.Columns.Add("VxCAN_COMPortBaudRate", "VxCAN_COMPortBaudRate");
            dataGridView1.Columns.Add("VxCAN_NameStr", "VxCAN_NameStr");
            dataGridView1.Columns.Add("VxCAN_VerStr", "VxCAN_VerStr");
            dataGridView1.Columns.Add("VxCAN_LocalPortIDList", "VxCAN_LocalPortIDList");

 

            for (int i = 0; i < 50; i++)
            {
                //Set Default Value
                _VxCAN_NameStr[i] = new String('\0',50);
                _VxCAN_VerStr[i] = new String('\0', 50);
            }



            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_TotalCANPort(ref _TotalVxCANPort, _VxCAN_NameIDList, _VxCAN_IDList, _VxCAN_COMPortBaudRate, _VxCAN_NameStr, _VxCAN_VerStr, _VxCAN_LocalPortIDList);
            if (ret == 0)
            {
                for (int i = 0; i < _TotalVxCANPort; i++)
                {
                    dataGridView1.Rows.Add();
                    dataGridView1["VxCANPort", dataGridView1.Rows.Count - 1].Value = i;
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_IDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_IDList[i];

                    //2026C is not a UART module so its VxCAN_COMPortBaudRate = 0xFFFFFFFF
                    //we use -1 to represent that
                    if (_VxCAN_COMPortBaudRate[i] == 0xFFFFFFFF)                                                        
                        dataGridView1["VxCAN_COMPortBaudRate", dataGridView1.Rows.Count - 1].Value = -1;                 
                    else
                        dataGridView1["VxCAN_COMPortBaudRate", dataGridView1.Rows.Count - 1].Value = _VxCAN_COMPortBaudRate[i];
                    dataGridView1["VxCAN_NameStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameStr[i];
                    dataGridView1["VxCAN_VerStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_VerStr[i];
                    dataGridView1["VxCAN_LocalPortIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_LocalPortIDList[i];
                }            
            }
        }
         

        private void Btn_OpenCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_OpenCAN((Byte)dataGridView1.CurrentRow.Index, (UInt32)VxCAN_DotNET.VxCAN_DotNET.CAN_BaudRate.BR_1000K);
            if (ret == 0)
            {
                MessageBox.Show("Open CAN Port 0 done!!");
            }
            VxCAN_port = (Byte)dataGridView1.CurrentRow.Index;
        }

        private void Btn_CloseCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(0);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearTxBuffer(0);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CloseCAN(0);

        }


        private void Btn_SendCANMsg_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID =(Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            //clear dataGridView2
            dataGridView2.Columns.Clear();
            dataGridView2.Rows.Clear();

            // operation State is checked.
            if (rd1.Checked)
            {
				//Clean buffer for Latest Data
				VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort); 
				

                //Set 1 second interval of event timer 
				ID = 0x600 + NumID;
                Len = 0x8;
                Data[0] = 0x2B;
                Data[1] = 0x01;
                Data[2] = 0x18;
                Data[3] = 0x05;
                Data[4] = 0xE8;
                Data[5] = 0x03;
                Data[6] = 0x00;
                Data[7] = 0x00;                
				VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

				//Initialize Graphics								
          		Graphics g = textBox1.CreateGraphics();
				g.Clear(Color.White);
			    Pen p = new Pen(Color.Blue,3);
			    
				//Draw X Y axis. Limit max time = 180 seconds and voltage = 10V
				p.DashStyle = DashStyle.Solid;
				p.EndCap = LineCap.ArrowAnchor;			    
                g.DrawLine(p, TOX(0), TOY(0), TOX(180), TOY(0));
			    g.DrawLine(p, TOX(0), TOY(0), TOX(0), TOY(10));   
				
				//Draw separate line for voltage range
				p.DashStyle = DashStyle.Dash;
				g.DrawLine(p, TOX(0), TOY(2.5f), TOX(180), TOY(2.5f));
				g.DrawLine(p, TOX(0), TOY(5), TOX(180), TOY(5));
				g.DrawLine(p, TOX(0), TOY(7.5f), TOX(180), TOY(7.5f));
			    
				//Initialize time, last voltage data and enable Timer
				count = 0; 
				VoltLast = 0;
				Timer1.Tick += new EventHandler(Timer1_Tick);
				Timer1.Interval = 1000;
				Timer1.Enabled = true;
                timer2.Enabled = false;
                dataGridView2.Visible = false;

            }
            //digital input
            if (rd3.Checked)
            {
                //Clean buffer for Latest Data
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

                //Set 1 second interval of event timer 
                ID = 0x600 + NumID;
                Len = 0x8;
                Data[0] = 0x2B;
                Data[1] = 0x00;
                Data[2] = 0x18;
                Data[3] = 0x05;
                Data[4] = 0xE8;
                Data[5] = 0x03;
                Data[6] = 0x00;
                Data[7] = 0x00;
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

                dataGridView2.Columns.Add("ID", "ID");
                dataGridView2.Columns.Add("Mode", "Mode");
                dataGridView2.Columns.Add("RTR", "RTR");
                dataGridView2.Columns.Add("Len", "Len");
                dataGridView2.Columns.Add("DI0", "DI0");
                dataGridView2.Columns.Add("DI1", "DI1");
                dataGridView2.Columns.Add("MsgTimeStamps", "MsgTimeStamps");

                dataGridView2.Columns["ID"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["Mode"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["RTR"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["Len"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["DI0"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["DI1"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["MsgTimeStamps"].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;

                //Start Timer2 ,stop timer1
                timer2.Enabled = true;
                Timer1.Enabled = false;
                dataGridView2.Visible = true;
 
            }
            //Analog output
            if (rd4.Checked)
            {
                //Clean buffer for Latest Data
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);
                
                //convert volt to 0x000~0x7FF( 0V ~ 10V) or 0x800~0xFFF(-10V ~ 0V)
                Int32 convert;
                float volt = 0;
                volt = float.Parse(textBox4.Text);
                if (volt > 10 || volt < -10)
                    convert = 0;
                else if (volt >= 0)
                    convert = (int)(volt / ((float)10.0 / 2047.0));
                else
                {
                    convert = 0xFFF + (int)(volt / ((float)10.0 / 2048.0));
                    if (convert == 0x7FF)
                        convert = 0x800;
                }

                //set analog output value and send 
                ID = 0x600 + NumID;
                Len = 0x8;
                Data[0] = 0x2B;
                Data[1] = 0x11;
                Data[2] = 0x64;
                Data[3] = 0x01;
                Data[4] = (byte)(convert % 256);
                Data[5] = (byte)(convert / 256);
                Data[6] = 0x00;
                Data[7] = 0x00;
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

                //stop timers
                timer2.Enabled = false;
                Timer1.Enabled = false; 

            }
            //Digital output
            if (rd5.Checked)
            {
                //Clean buffer for Latest Data
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

                //get 1bit from textbox5 ,set digital output value and send 
                byte bit;
                bit = byte.Parse(textBox5.Text);

                ID = 0x600 + NumID;
                Len = 0x8;
                Data[0] = 0x2F;
                Data[1] = 0x00;
                Data[2] = 0x62;
                Data[3] = 0x01;
                if (bit == 1)
                    Data[4] = 0x01;
                else if (bit == 0)
                    Data[4] = 0x00;
                Data[5] = 0x00;
                Data[6] = 0x00;
                Data[7] = 0x00;
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

                timer2.Enabled = false;
                Timer1.Enabled = false;


            }

            // Operation State is checked.
            if (rd2.Checked)
            {
                ID = 0x000;
                Len = 0x2;
                Data[0] = 0x01;
                Data[1] = DataID;
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data); 
				MessageBox.Show("CAN2026C is in operation mode!");
            }


          
        }


        private void Btn_ResetCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ResetCAN(0);
            if(ret == 0)
                MessageBox.Show("Reset CAN Port 0 done!");
        }

        private void Btn_CANStatus_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            UInt32 ModuleStatus = 0;
            UInt32 CANChipStatus = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CANStatus(0, ref ModuleStatus, ref CANChipStatus);
            if(ret == 0)
            {
                MessageBox.Show("Module Status = "+ModuleStatus.ToString());
                MessageBox.Show("CAN Chip Status = " + CANChipStatus.ToString());
            }
        }

        private void Timer1_Tick(object sender, System.EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            byte VxCANPort = VxCAN_port, rMode = 0, rRTR = 0, rLen = 0;
            byte[] rData = new Byte[8];
            UInt32 ret = 0, rID = 0;
            Double rMsgTimeStamps = 0;
			double Vch = 0;
			float Volt = 0;
			
			//Initialize voltage and time characters
   			System.Drawing.Font drawFont = new System.Drawing.Font("Arial", 8);
   			System.Drawing.SolidBrush drawBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Black);
    		float x = 0.0F;
    		float y = 0.0F;
			System.Drawing.StringFormat drawFormat = new System.Drawing.StringFormat();
			
			//Initialize graphics, voltage and time
			Graphics g = textBox1.CreateGraphics();
			Graphics gV = textBox2.CreateGraphics();
			Graphics gT = textBox3.CreateGraphics();
			Pen p = new Pen(Color.Black, 3);
		                                       
			ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_Receive(VxCANPort, ref rID, ref rMode, ref rRTR, ref rLen, rData, ref rMsgTimeStamps);
			if(ret == 0)
            {
				//Clean buffer for Latest Data
				VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

                if (rID == (0x280 + NumID))
				{     			
					//Default voltage level range between -10V ~ 10V and output corresponding data range as 0x8000(-32768) ~ 0x7FFF(32767)
					//Convert output data to the corresponding voltage value and formula is below
					Vch = (((rData[1] * 256 + rData[0]) + 32768) * 20) / 65535.0 - 10;
					Vch = Math.Round(Vch, 3);
					Volt = (float)Vch;				
                    
					//Reset graphics when 180 seconds of arrival 
                    if (count == 180 || count == 0) 
					{
						count = 0;
						g.Clear(Color.White);
						p = new Pen(Color.Blue,3);
			
						//Draw X Y axis. Limit max time = 180 seconds and voltage = 10V
						p.DashStyle = DashStyle.Solid;
						p.EndCap = LineCap.ArrowAnchor;			    
                		g.DrawLine(p, TOX(0), TOY(0), TOX(180), TOY(0));
			    		g.DrawLine(p, TOX(0), TOY(0), TOX(0), TOY(10));   
				
						//Draw separate line for voltage range
						p.DashStyle = DashStyle.Dash;
						g.DrawLine(p, TOX(0), TOY(2.5f), TOX(180), TOY(2.5f));
						g.DrawLine(p, TOX(0), TOY(5), TOX(180), TOY(5));
						g.DrawLine(p, TOX(0), TOY(7.5f), TOX(180), TOY(7.5f));
					}

                    //ignore that voltage
					if (Volt > 10) Volt = 0;

					//Mark point in two dimensional coordinate with 0.25f difference for matching coordinate 
					g.FillEllipse(Brushes.Red, TOX(count), TOY(Volt+0.25f), 6, 6);
					
					//Draw trand chart with black line
					if (count != 0)
					{
						g.DrawLine(p, TOX(count-1), TOY(VoltLast), TOX(count), TOY(Volt));
					}
					
					//Show time and voltage value
					gV.Clear(Color.White);
					gT.Clear(Color.White);
					gV.DrawString(Volt.ToString() + " V", drawFont, drawBrush, x, y, drawFormat);
					gT.DrawString(count.ToString() + " s", drawFont, drawBrush, x, y, drawFormat);
					
					//increase time and record last voltage value for trend chart
					count++;
					VoltLast = Volt;
				}				
            }
        }
        //
        private void timer2_Tick(object sender, EventArgs e)
        {
            //Initialize parameters
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            byte Mode = 0, RTR = 0, Len = 0;
            byte[] Data = new Byte[8];
            ushort RxCnt = 0;
            UInt32 ret = 0, ID = 0;
            Double MsgTimeStamps = 0;
            UInt32 TimeOut = 0;
            int bit0 = 0, bit1 = 0;


            while (true && TimeOut++ < 20000)
            {
                //get the amount of CAN message in Virtual CAN buffer
                ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_RxMsgCount(VxCAN_port, ref RxCnt);
                int currentRowIndexInt;
                if (ret == 0)
                {
                    if (RxCnt > 0)
                    {
                        //output all CAN message in Virtual CAN buffer
                        for (int i = 0; i < RxCnt; i++)
                        {
                            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_Receive(VxCAN_port, ref ID, ref Mode, ref RTR, ref Len, Data, ref MsgTimeStamps);
                            if (ret == 0)
                            {
                                if (ID == (0x180 + NumID))
                                {
                                    bit0 = Data[0] & 1;             //get bit0
                                    bit1 = (Data[0] & 2)>>1;        //get bit1
                                    dataGridView2.Rows.Add();
                                    dataGridView2["ID", dataGridView2.Rows.Count - 1].Value = ID.ToString("X3");
                                    dataGridView2["Mode", dataGridView2.Rows.Count - 1].Value = Mode.ToString("X1");
                                    dataGridView2["RTR", dataGridView2.Rows.Count - 1].Value = RTR.ToString("X1");
                                    dataGridView2["Len", dataGridView2.Rows.Count - 1].Value = Len.ToString("X1");
                                    dataGridView2["DI0", dataGridView2.Rows.Count - 1].Value = bit0.ToString();
                                    dataGridView2["DI1", dataGridView2.Rows.Count - 1].Value = bit1.ToString();
                                    dataGridView2["MsgTimeStamps", dataGridView2.Rows.Count - 1].Value = MsgTimeStamps.ToString();

                                    currentRowIndexInt = dataGridView2.Rows.Count - 1;
                                    dataGridView2.CurrentCell = dataGridView2[0, currentRowIndexInt];
                                    
                                }
                            }
                        }
                        break;
                    }
                }
            }

        }
		
		//To fit the graphics scale of X axis
		float TOX(float a1)
        {
            float x;                           
			 x = 5 + (textBox1.Width - 0) / (float)(183.0) * a1;	
            return x;
        }

		//To fit the graphics scale of Y axis 
		float TOY(float b1)
        {
            float y;                       		
			y = textBox1.Height - 10 - (textBox1.Height - 0) / (float)(10.8) * b1;	
            return y;
        }
        


        private void Btn_SendStopMsg_Click(object sender, EventArgs e)
        {
			UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ret = 0, ID = 0x000;
            Byte[] Data = new Byte[8];
						
			//Set 0 second interval of event timer to disable event timer
			ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2B;
            Data[1] = 0x01;
            Data[2] = 0x18;
            Data[3] = 0x05;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);		
			if (ret != 0)
            {
                MessageBox.Show("Close Event Timer Fail!!");
            }	
			
			//Stop timer
			Timer1.Enabled = false;

            //Set 0 second interval of event timer to disable event timer
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2B;
            Data[1] = 0x00;
            Data[2] = 0x18;
            Data[3] = 0x05;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
            if (ret != 0)
            {
                MessageBox.Show("Close Event Timer Fail!!");
            }

            //Stop timer
            timer2.Enabled = false;
        }

       
    }
}
